# Resonance Rifle

### A model and particle mod for the Charge Rifle, themed after the Pyramids from Destiny 2.

<br>

> ## **Contact:**
> ### In case of any crashes and/or questions ping me (S2ymi#6601) on the Official Northstar Discord in the #modding-chat channel

<hr>

# Previews:

![image](https://cdn.discordapp.com/attachments/974722927704539166/1109092811334225920/resonance_rifle_render.png)

### <a href="https://youtu.be/c5A9K_ODrSA">Scroll-Click me to open a preview video in a new page!</a>

# Changelog:

- v1.1.1:
	- Made compatible with NS merged ModSettings

- v1.1.0:
    - Added a custom kill counter
    - Settings are in the Settings section
    - A preview image is at the bottom of the page

- v1.0.1:
    - Updated Thunderstore icon
    - Removed the 3rd person charge up effect
    - *Unfortunately necessary due to edited particles showing up through walls sometimes :(*

<hr>

# Manual Settings:

- Audio:
    - Go to the Mod's folder (`...\Titanfall2\R2Northstar\mods\S2.ResonanceRifle\`)
    - To disable the custom firing sound simply delete or rename the `audio` folder

### To switch between Normal and Chromatic Mode fully you'll have to edit some mods files.

As the button toggle in the settings only handles the Charge and Neon colours, you'll have to swap particles and materials by hand.

- Particles:
    - Go to the Mod's folder (`...\Titanfall2\R2Northstar\mods\S2.ResonanceRifle\`)
    - Enter the `...\mod\particles\` folder
    - In that folder you'll see 2 other folders and 2 `.pcf` files, the `.pcf` files are the active particles
    - To switch between Modes, simply replace the active particle files with ones copied from either the `Basic` or `Chromatic` folder
- Materials:
    - Go to the Mod's folder (`...\Titanfall2\R2Northstar\mods\S2.ResonanceRifle\`)
    - Enter the `...\mod\materials\models\weapons\defender_custom` folder
    - Open `glass.vmt` with a text editor (Notepad, Notepad++ etc.)
    - Follow the instructions in that file

### To change the colour of the glass parts, follow the Materials guide above.

# Settings:
- Chromatic Mode
    - *This is an RGB-like Mode for the entire Mod*
    - ***The button for this mode only enables a part of the Mode, refer to the above section for full instructions***
    - On/Off
    - *Additionally, a button to open this page has been included*
- Pro Screen
    - Numbers Colour
        - Can be above 1
    - Numbers Alpha
    - Numbers Font
    - P Key bind
        - Allows you to change what the Pro Screen displays by pressing P
             - Kill Count, Clock, Ammo Count, Custom Number, Off
    - Timezone
        - For the Clock mode
        - London Time +- your hour offset
    - Custom number
        - 5 digits max
    - Flame Colour
        - Can be above 1
    - Flame Alpha
- Neon
    - Main Colour
    - Main Colour Intensity
    - Kill Reactive On/Off
    - Kill Reactive Transition Time
    - Secondary Colour
    - Secondary Colour Intensity
    - *Secondary Options only concern the Kill Reactive mode*
- Charge
    - *Settings for the "Batteries" on the sides of the gun*
    - Colour
    - Colour Intensity
    - Base Alpha *(Sets how opaque the colour is, even at 0 charge)*
- Muzzle Luster Tree
    - *Controls a semi-transparent black "Tree" which grows out of the gun's muzzle*
    - On/Off
    - Duration
    - Size
- Impact Luster Tree
    - *Controls a "Tree" which grows out of the impact point*
    - On/Off
    - Type
        - `Smoke` *(Same as the muzzle one)*
        - `Glass` *(Orange, semi transparent and refracting)*
        - `Chromatic` *(Same as `Glass` but more smooth and multi-coloured)*
    - Duration
    - Size
    - Precision
        - `High` should always place the tree right in the impact point but only works when fully ADSed
        - `Low` will always spawn the tree, but it may not be 100% accurate
        - *This unforunately is an effect of Respawn's limitations on controlling particles from script :(*

<hr>

# In-Game Screenshots:

![image](https://cdn.discordapp.com/attachments/974722927704539166/1114990298360205352/image.png)