untyped
global function resonanceRifleInit
global function resonanceRifleUI
#if SERVER || CLIENT
global function OnWeaponPrimaryAttack_weapon_resonance_rifle
#endif
#if CLIENT
global function VMTCallback_resonance_kill_count
#endif

void function resonanceRifleInit(){
    #if CLIENT
        thread resonanceRifleMain()
        #if S2_RR_KILL_CALLBACK
            AddCallback_OnPlayerKilled(resonanceRifleKillCallback)
            RegisterButtonPressedCallback(KEY_P, counterSwitch)
        #endif
    #endif
}

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}
/*
string function floatColToHex(vector input){
    array<string> letters = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"]
    input *= 256
    array<int> nums = [input.x.tointeger(), input.y.tointeger(), input.z.tointeger()]
    string result = ""
    foreach(x in nums){
        if(x > 256)
            x = 256
        if(x < 0)
            x = 0
        int xMod16 = x%16
        int firstLetterNum = (x-xMod16)/16 - 1
        result += letters[firstLetterNum]
        result += letters[xMod16]
    }
    return result
}
*/
void function resonanceRifleUI(){
    #if UI
        #if S2_RR_KILL_CALLBACK
            printt("[S2.RR] Player has ClientKillCallback.")
        #else
            thread noCallbackThread()
        #endif

        ModSettings_AddModTitle("S2.ResonanceRifle")
        ModSettings_AddModCategory("Chromatic Mode")
            ModSettings_AddEnumSetting("s2_rr_chromatic", "^ffff0000Chro^00ffff00matic^ff00ff00 Mode", ["Off", "On"])
            ModSettings_AddButton("Open full Mode-switch guide", guideOpen)
        ModSettings_AddModCategory("Pro Screen")
            ModSettings_AddSetting("s2_rr_ps_n_col", "Numbers ^ff000000Co^00ff0000lo^0000ff00ur", "vector")
            ModSettings_AddSliderSetting("s2_rr_ps_n_alpha", "Numbers Alpha", 0.0, 1.0, 0.01, true)
            ModSettings_AddEnumSetting("s2_rr_ps_n_font", "Numbers Font", ["Electronic Clock", "Fancy"])
            ModSettings_AddEnumSetting("s2_rr_ps_button", "P Key bind", ["P Unbound", "On/Off", "Additional Modes"])
            ModSettings_AddSetting("s2_resonance_time_zone", "Timezone (GMT + input)", "float")
            ModSettings_AddSetting("s2_rr_ps_n_cstm_num", "Custom Number", "float")
            ModSettings_AddSetting("s2_rr_ps_f_col", "Flame ^ff000000Co^00ff0000lo^0000ff00ur", "vector")
            ModSettings_AddSliderSetting("s2_rr_ps_f_alpha", "Flame Alpha", 0.0, 1.0, 0.01, true)
        ModSettings_AddModCategory("Neon")
            //ModSettings_AddSetting("s2_rr_col", "^" + floatColToHex(GetConVarFloat3("s2_rr_col")) + "00Main Colour^e0e0e000", "vector")
            ModSettings_AddSetting("s2_rr_col", "Main ^ff000000Co^00ff0000lo^0000ff00ur", "vector")
            ModSettings_AddSetting("s2_rr_int", "Main Colour ^55555500Int^aaaaaa00ens^ffffff00ity", "float")
            ModSettings_AddEnumSetting("s2_rr_kill_reactive", "Kill Reactive", ["Off", "On"])
            ModSettings_AddSetting("s2_rr_kill_time", "Kill Reactive Transition Time", "float")
            ModSettings_AddSetting("s2_rr_col_2", "Secondary ^ff000000Co^00ff0000lo^0000ff00ur", "vector")
            ModSettings_AddSetting("s2_rr_int_2", "Secondary Colour ^55555500Int^aaaaaa00ens^ffffff00ity", "float")
        ModSettings_AddModCategory("Charge")
            ModSettings_AddSetting("s2_rr_charge_col", "Charge ^ff000000Co^00ff0000lo^0000ff00ur", "vector")
            ModSettings_AddSetting("s2_rr_charge_int", "Charge Colour ^55555500Int^aaaaaa00ens^ffffff00ity", "float")
            ModSettings_AddSliderSetting("s2_rr_charge_alpha", "Base Alpha", 0.0, 1.0, 0.01, true)
        ModSettings_AddModCategory("Muzzle Luster Tree")
            ModSettings_AddEnumSetting("s2_rr_luster_muzzle", "Muzzle Flash Tree", ["Off", "On"])
            ModSettings_AddSetting("s2_rr_luster_muzzle_time", "Muzzle Flash Tree Duration", "float")
            ModSettings_AddEnumSetting("s2_rr_luster_size", "Muzzle Tree Size", ["Small", "Big"])
        ModSettings_AddModCategory("Impact Luster Tree")
            ModSettings_AddEnumSetting("s2_rr_luster_impact", "Impact Tree", ["Off", "On"])
            ModSettings_AddEnumSetting("s2_rr_luster_impact_type", "Impact Tree Type", ["Smoke", "Glass", "Chromatic"])
            ModSettings_AddSetting("s2_rr_luster_impact_time", "Impact Tree Duration", "float") 
            ModSettings_AddSetting("s2_rr_luster_size_impact", "Impact Tree Size", "float")
            ModSettings_AddEnumSetting("s2_rr_luster_precision", "Impact Tree Precision", ["High", "Low"])
    #endif
}

#if UI
void function guideOpen(){
    DialogData guidePopUp
    guidePopUp.header = "Resonance Rifle"
    guidePopUp.message = "Open Thunderstore Mod page?"
    guidePopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(guidePopUp, "No", void function(){})
    AddDialogButton(guidePopUp, "Yes", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/S2Mods/ResonanceRifle/", WEBBROWSER_FLAG_FORCEEXTERNAL)
    })
    AddDialogButton(guidePopUp, "Open Titanfall 3 Leaks", void function(){
        LaunchExternalWebBrowser("https://youtu.be/dQw4w9WgXcQ", WEBBROWSER_FLAG_FORCEEXTERNAL)
    })
    OpenDialog(guidePopUp)
}

void function noCallbackThread(){
    WaitFrame()
    noCallbackDiag()
}

void function noCallbackDiag(){
    DialogData errorPopUp
    errorPopUp.header = "MISSING REQUIRED DEPENDENCY"
    errorPopUp.message = "ResonanceRifle requires S2.ClientKillCallback to function.\nThe mod was not found; please download it."
    errorPopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(errorPopUp, "Exit", void function(){ ClientCommand("exit") })
    AddDialogButton(errorPopUp, "Download", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/S2Mods/ClientKillCallback/", WEBBROWSER_FLAG_FORCEEXTERNAL)
        noCallbackDiag()
    })
    OpenDialog(errorPopUp)
}
#endif

#if CLIENT

float function logAnyDecrease(float x, float coefficient){
    if(coefficient > 0.0){
        float k = (1.0/coefficient)
        float b = -(1.0/(pow(2.71828, k) - 1.0))
        float c = (1.0 + (coefficient * log(1.0/(pow(2.71828, k) - 1.0))))
        return ((coefficient * -(log(x - b))) + c)
    }
    else{
        return -1.0
    }
    unreachable
}

float lastKillTime = -1.0
float lastShotTime = -1.0

void function resonanceRifleKillCallback(ObituaryCallbackParams inputParams){
    if(!IsValid(inputParams.attacker) || inputParams.attacker == null)
		return
	entity player = GetLocalClientPlayer()
	if(!IsValid(player) || player == null)
		return
	if(inputParams.attacker != player)
		return
	entity weapon = player.GetActiveWeapon()
	if(!IsValid(weapon) || weapon == null)
		return
	if(DamageSourceIDToString(inputParams.damageSourceId) != "mp_weapon_defender")
		return
    lastKillTime = Time()
    
}

float impactTreeBaseControlPointA = 0.0
float impactTreeTopControlPointA = 0.0

array<asset> treeTypes = [$"s2_luster_tree_impact_smoke", $"s2_luster_tree_impact_glass", $"s2_luster_tree_impact_chromatic"]

void function resonanceRifleMain(){
    foreach(particle in treeTypes)
        PrecacheParticleSystem(particle)
    while("true"){
        WaitFrame()
        if(IsMenuLevel() || IsLobby())
			continue
        entity player = GetLocalClientPlayer()
		if(player == null || !IsValid(player) || GetLocalViewPlayer() != player)
            continue
        entity weapon = player.GetActiveWeapon()
        if(!IsValid(weapon))
			continue
        if(weapon.GetWeaponClassName() == "mp_weapon_defender"){
            if(GetConVarInt("s2_rr_simulate_kill") == 1){
                lastKillTime = Time()
                SetConVarInt("s2_rr_simulate_kill", 0)
            }
            vector mainCol = GetConVarFloat3("s2_rr_col")
            vector secondCol = GetConVarFloat3("s2_rr_col_2")
            vector chargeCol = GetConVarFloat3("s2_rr_charge_col")
            int chromaticMode = GetConVarInt("s2_rr_chromatic")
            int killReactive = GetConVarInt("s2_rr_kill_reactive")
            int impactFX = GetConVarInt("s2_rr_luster_impact")
            int muzzleFX = GetConVarInt("s2_rr_luster_muzzle")
            int treeSize = GetConVarInt("s2_rr_luster_size")
            float mainInt = GetConVarFloat("s2_rr_int")
            float secondInt = GetConVarFloat("s2_rr_int_2")
            float chargeInt = GetConVarFloat("s2_rr_charge_int")
            float minChargeA = GetConVarFloat("s2_rr_charge_alpha")
            float killTime = GetConVarFloat("s2_rr_kill_time")
            float muzzleTreeTime = GetConVarFloat("s2_rr_luster_muzzle_time")
            float impactTreeTime = GetConVarFloat("s2_rr_luster_impact_time")

            vector neonFinal = <0.0, 0.0, 0.0>
            float neonIntFinal = 0.0
            if(chromaticMode){
                neonIntFinal = 1.5 + 0.5*cos(3*(Time() + PI/6))
                neonFinal.x = sin(Time()) + 2.0
                neonFinal.y = sin(Time() + 2*PI/3) + 2.0
                neonFinal.z = sin(Time() + 4*PI/3) + 2.0
                
                float chargeRampUp = (13.0 * weapon.GetWeaponChargeFraction() * weapon.GetWeaponChargeFraction())
                float sineArg = Time() + chargeRampUp
                chargeCol.x = sin(sineArg) + 0.75
                chargeCol.y = sin(sineArg + 2*PI/3) + 0.75
                chargeCol.z = sin(sineArg + 4*PI/3) + 0.75
                chargeCol = Normalize(chargeCol)
                chargeInt = 2.5
                minChargeA = 0.5

                muzzleFX = 0
                impactFX = 1
            }
            else if(killReactive && Time() - lastKillTime <= killTime){
                float logFrac = logAnyDecrease((Time() - lastKillTime)/killTime, 0.5)
                neonFinal = logFrac*secondCol + (1-logFrac)*mainCol
                neonIntFinal = logFrac*secondInt + (1-logFrac)*mainInt
            }
            else{
                neonFinal = mainCol
                neonIntFinal = mainInt
            }
            vector flameCol = GetConVarFloat3("s2_rr_ps_f_col")
            vector numbersCol = GetConVarFloat3("s2_rr_ps_n_col")
            if(chromaticMode){
                numbersCol = neonFinal
                flameCol = Vector(sin(2*PI*Time()), sin(2*PI*Time() + 2*PI/3), sin(2*PI*Time() + 4*PI/3))
            }
            SetConVarFloat("s2_resonance_flame_r", flameCol.x)
            SetConVarFloat("s2_resonance_flame_g", flameCol.y)
            SetConVarFloat("s2_resonance_flame_b", flameCol.z)
            SetConVarFloat("s2_resonance_num_r", numbersCol.x)
            SetConVarFloat("s2_resonance_num_g", numbersCol.y)
            SetConVarFloat("s2_resonance_num_b", numbersCol.z)
            neonFinal *= neonIntFinal
            chargeCol *= chargeInt
            float chargeFrac = clamp(weapon.GetWeaponChargeFraction(), 0.0, 1.0)
            SetConVarFloat("s2_rr_charge_a", (minChargeA + (1-minChargeA)*sqrt(chargeFrac)))
            SetConVarFloat("s2_resonance_neon_r", neonFinal.x)
            SetConVarFloat("s2_resonance_neon_g", neonFinal.y)
            SetConVarFloat("s2_resonance_neon_b", neonFinal.z)
            SetConVarFloat("s2_resonance_charge_r", chargeCol.x)
            SetConVarFloat("s2_resonance_charge_g", chargeCol.y)
            SetConVarFloat("s2_resonance_charge_b", chargeCol.z)

            float muzzleTreeBaseAlpha = 0.0
            float muzzleTreeTopAlpha = 0.0
            float sDif = Time() - lastShotTime // time since last shot
            if(muzzleFX && sDif <= muzzleTreeTime){
                float treeMuzzleAlphaSet = lusterAlpha(sDif/muzzleTreeTime)
                muzzleTreeBaseAlpha = treeMuzzleAlphaSet
                if(treeSize)
                    muzzleTreeTopAlpha = treeMuzzleAlphaSet
                else
                    muzzleTreeTopAlpha = 0.0
            }
            SetConVarFloat("s2_rr_luster_muzzle_base_a", muzzleTreeBaseAlpha)
            SetConVarFloat("s2_rr_luster_muzzle_top_a", muzzleTreeTopAlpha)
        }
    }
}

int counterMode = 1

void function counterSwitch(var button){
    if(GetConVarInt("s2_rr_ps_button") == 1)
        counterMode = (counterMode + 1)%2
    if(GetConVarInt("s2_rr_ps_button") == 2)
        counterMode = (counterMode + 1)%5
}

var function VMTCallback_resonance_kill_count(entity weapon){
    if(GetLocalViewPlayer() != GetLocalClientPlayer())
        return -1
    switch(counterMode){
        case 0:
            return -1
        break;
        case 1:
            return WeaponGetProScreenKills(GetLocalClientPlayer(), "mp_weapon_defender")
        break;
        case 2:
            int seconds = GetUnixTimestamp()
            int hours = (seconds/3600 + int(GetConVarFloat("s2_resonance_time_zone"))) % 24
            int minutes = (seconds/60) % 60
            return (100*hours + minutes)
        break;
        case 3:
            return GetLocalClientPlayer().GetActiveWeapon().GetWeaponPrimaryAmmoCount()
        break;
        case 4:
            return int(GetConVarFloat("s2_rr_ps_n_cstm_num"))
        break;
        default:
            return 99999
        break;
    }
    unreachable
}

float function lusterAlpha(float x){
    if(x < 0.0 || x > 1.0)
        return 0.0
    if(x <= 0.1)
        return sqrt(10*x)
    if(x <= 0.5)
        return 1.0
    if(x <= 1.0)
        return sqrt(2.0*(1-x))
    unreachable
}

float function lusterSize(float x){
    if(x < 0.0 || x > 1.0)
        return 0.0
    if(x <= 0.1)
        return sqrt(10*x)
    if(x <= 0.9)
        return 1.0
        //return (-0.2*(x-0.5)*(x-0.5)+1.032)
    if(x <= 1.0)
        return sqrt(10*(1-x))
    unreachable
}

void function setImpactSettings(int fxHandle, float startTime, vector pos, vector forward){
    float impactTreeTime = GetConVarFloat("s2_rr_luster_impact_time")
    while(EffectDoesExist(fxHandle) && Time() - startTime <= impactTreeTime){
        float tFrac = (Time()-startTime)/impactTreeTime
        float treeAlpha = lusterAlpha(tFrac)
        float treeSize = GetConVarFloat("s2_rr_luster_size_impact")*lusterSize(tFrac)//(GetConVarFloat("s2_rr_luster_size_impact"))*(1-((2*tFrac - 1)*(2*tFrac - 1)))
        vector treeTimePos = pos
        /*if(tFrac < 0.9)
            treeTimePos -= 10*(10*tFrac-9)*forward
        else if(tFrac > 0.1){
            treeTimePos -= 10*(1-10*tFrac)*forward
        }
        printt("\n\n\nTREE SIZE: " + treeSize)
        printt("\nTREE ORG POS: " + pos)
        printt("\nTREE POST POS: " + treeTimePos + "\n\n")*/
        EffectSetControlPointVector(fxHandle, 2, Vector(treeAlpha, treeSize, impactTreeTime))
        //EffectSetControlPointVector(fxHandle, 1, treeTimePos)
        WaitFrame()
    }
}

#endif

#if CLIENT || SERVER

var function OnWeaponPrimaryAttack_weapon_resonance_rifle( entity weapon, WeaponPrimaryAttackParams attackParams )
{
	if ( weapon.GetWeaponChargeFraction() < 1.0 )
		return 0
    
    //impact
    //TRACE_COLLISION_GROUP_BLOCK_WEAPONS, TRACE_COLLISION_NONE, TRACE_MASK_NPCSOLID
    #if CLIENT
        entity player = GetLocalClientPlayer()
        //int sussy = PlayFXOnTag( weapon, GetParticleSystemIndex($"wpn_muzzleflash_xo_elec_FP"), weapon.LookupAttachment("muzzle_flash") )
        //printt("\n\n Effect num: " + sussy + "\nParticle Num: " + GetParticleSystemIndex($"wpn_muzzleflash_xo_elec_FP") + "\n")
        if(player == weapon.GetWeaponOwner() && GetConVarInt("s2_rr_luster_impact") && (GetConVarInt("s2_rr_luster_precision") || player.GetZoomFrac() == 1.0)){
            vector forward = attackParams.dir
            TraceResults trace = TraceLine(attackParams.pos, attackParams.pos + (5555555555 * forward), null, TRACE_MASK_NPCSOLID )
            int fxHandle = 0
            if(GetConVarInt("s2_rr_chromatic"))
                fxHandle = StartParticleEffectInWorldWithHandle(GetParticleSystemIndex($"s2_luster_tree_impact_chromatic"), <0, 0, 0>, <0, 0, 0>)
            else
                fxHandle = StartParticleEffectInWorldWithHandle(GetParticleSystemIndex(treeTypes[GetConVarInt("s2_rr_luster_impact_type")]), <0, 0, 0>, <0, 0, 0>)
            EffectSetControlPointVector(fxHandle, 0, trace.surfaceNormal)
            EffectSetControlPointVector(fxHandle, 1, trace.endPos)
            EffectSetControlPointVector(fxHandle, 2, Vector(0.0, 0.0, GetConVarFloat("s2_rr_luster_impact_time")))
            thread setImpactSettings(fxHandle, Time(), trace.endPos, AnglesToForward(VectorToAngles(trace.surfaceNormal)))
        }
    #endif

	return FireDefender( weapon, attackParams )
}

int function FireDefender( entity weapon, WeaponPrimaryAttackParams attackParams )
{
	weapon.EmitWeaponNpcSound( LOUD_WEAPON_AI_SOUND_RADIUS_MP, 0.2 )
	weapon.FireWeaponBullet( attackParams.pos, attackParams.dir, 1, DF_GIB | DF_EXPLOSION )
    #if CLIENT
        if(weapon.GetWeaponOwner() == GetLocalClientPlayer())
            lastShotTime = Time()
    #endif
	return 1
}

#endif